' Sparrow-Atemtrainer
'
' Haftungsausschluss:
' -------------------
' Sie knnen das Gert auf eigene Verantwortung nutzen, jedoch keine Haftung daraus ableiten!
'
' Warnung: Das Gert beeinflusst Atmung, Herzschlag und Gehirnwellen und ist NUR fr Erwachsene.
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 16                                  '8
$swstack = 16                                  '4
$framesize = 16                                '4

Stop Watchdog : Stop Ac : Stop Adc             'Sprit sparen
Green Alias Portb.1 : Red Alias Portb.3

Mcucr = &B00110001                             'sleep enable, powerdown enable, pin change enable
Pcmsk = 1                                      'fr PCINT0
Gimsk = 32                                     'PCIE

'Zeitbasis + PWM
Config Timer0 = Pwm , Compare_b_pwm = Clear_up , Prescale = 1 :       '1,2MHz/511/1 ~2348,34Hz ~425,833us
On Ovf0 Tim0_isr : Enable Timer0 : Enable Interrupts : Start Timer0

Const 60_pro_min = 1174                        '0,5s+0,5s
Const 20_pro_min = 3522                        '1,5s+1,5s
Const 10_pro_min = 8218                        '3,5s+3,5s
Const Stufe = 96
Const _stufe = -96                             '~gesamtzeit ~35000/n

Declare Sub Ausgabe

Dim Delayms As Word
Dim I As Word

Do
   Ddrb = &B01010 : Portb = &B00001            'aux, red, S2, green, S1 : pullup

   For I = 20_pro_min To 60_pro_min Step _stufe : Ausgabe : Next I       'Anstieg

   For I = 60_pro_min To 10_pro_min Step Stufe : Ausgabe : Next I       'Abfall

   Ddrb = 0 :                                  'alles aus
   Portb = 1                                   'pullup fr S1
   sleep                                       'ab ins Bett
   nop                                         'wach geworden ?
Loop
'-------------------------------------------------------------------------------
Tim0_isr:
   Delayms = Delayms + 1
Return

Sub Ausgabe:
      Pwm0b = 128                              'Ton ein, Green = 1
      Red = 0
      Do : If Delayms = 20 Then Pwm0b = 255    'Ton aus, green = 1
      Loop Until I = Delayms : Delayms = 0
      Pwm0b = 0                                'Green = 0
      Red = 1
      Do : Loop Until I = Delayms : Delayms = 0
End Sub
'-------------------------------------------------------------------------------